#/*==========================================================================*
# *    Copyright(c) 2021, Vertiv Tech Co., Ltd.
# *                     ALL RIGHTS RESERVED
# *
# *  PRODUCT  : NGMC-HF(Next Generation Controller - High Feature)
# *
# *  FILENAME : Makefile
# *  CREATOR  : Frank Cao                DATE: 2008-06-24 16:47
# *  VERSION  : V1.00
# *  PURPOSE  :
# *
# *
# *  HISTORY  :
# *
# *==========================================================================*/

include $(ACU_SOURCE_DIR)/config_vars.mk

#the target output file
EXEC = main_board.so

#the head files the object files depend on
INCS = main_board.h

#the object files to generate the target
OBJS = main_board.o

SAMPLER_BASE_DIR=../sampler_base/

CFLAGS += -I$(SAMPLER_BASE_DIR)
CFLAGS += -D_DLL_	#to make DLL(.so) version

#for self test
TEST_EXEC = test_scu #the_test_file_execution
TEST_OBJS = #the_object_files_for_testing.o
TEST_LIBS = $(EXEC) #and other required libs

#private shared libraries
LIBS = #$(SAMPLER_BASE_DIR)/libsampler_base.a -lpub

all: $(EXEC)

$(EXEC): $(OBJS) $(INCS) $(PUBINCS)
	$(CC) -shared -fPIC $(CFLAGS) $(LDFLAGS) -o $@ $(OBJS) $(LIBS)
	ln -fs `pwd`/$(EXEC) $(ACU_SOURCE_DIR)/sampler/$(EXEC)
ifeq ($(ACU_MAKE_VERSION_N), debug)
install: $(EXEC)
	-mkdir -p $(ACU_TARGET_DIR)/sampler/
	#-cp $(EXEC) $(ACU_TARGET_DIR)/sampler/
	cp -fr $(EXEC) $(ACU_TARGET_DIR)/sampler/$(EXEC)
	chmod +x $(ACU_TARGET_DIR)/sampler/$(EXEC)	
else
install: $(EXEC)
	-mkdir -p $(ACU_TARGET_DIR)/sampler/
	#-cp $(EXEC) $(ACU_TARGET_DIR)/sampler/
	$(STRIP) -s -o $(ACU_TARGET_DIR)/sampler/$(EXEC) $(EXEC)
	chmod +x $(ACU_TARGET_DIR)/sampler/$(EXEC)
endif		
$(TEST_EXEC): $(EXEC) $(TEST_OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $(TEST_OBJS) $(TEST_LIBS)
	
test: $(TEST_EXEC)
	-echo Test making ...

clean:
	-rm -f $(EXEC) *.gdb *.elf *.o $(OBJS) core $(TEST_EXEC)
	-rm -f make_*.txt *.map *.so 
	-rm -f $(ACU_SOURCE_DIR)/sampler/$(EXEC)
	
